diff --git a/configure.ac b/configure.ac
index 5011221..e7ee60b 100644
--- a/configure.ac
+++ b/configure.ac
@@ -4222,16 +4146,15 @@ AM_CONDITIONAL([HAVE_GCRYPT], [test "${have_libgcrypt}" = "yes"])
 dnl
 dnl TLS/SSL
 dnl
-AC_ARG_ENABLE(gnutls,
-  [  --enable-gnutls         gnutls TLS/SSL support (default enabled)])
-
+VLC_FEATURE_DEFAULT_ENABLE([gnutls])
 AS_IF([test "${have_libgcrypt}" != "yes"], [
   AS_IF([VLC_FEATURE_REQUESTED([gnutls])], [
     AC_MSG_ERROR([--enable-gnutls and --disable-libgcrypt are mutually exclusive.])
   ])
   VLC_FEATURE_DEFAULT_DISABLE([gnutls])
 ])
-AS_IF([VLC_FEATURE_NOT_DISABLED([gnutls])], [
+VLC_FEATURE_OPTION([gnutls], [gnutls TLS/SSL support], [enabled if you have libgcrypt])
+AS_IF([VLC_FEATURE_ENABLED([gnutls])], [
   PKG_CHECK_MODULES(GNUTLS, [gnutls >= 1.7.4], [
     VLC_ADD_PLUGIN([gnutls])
     VLC_ADD_CFLAGS([gnutls], [$GNUTLS_CFLAGS])
@@ -4256,10 +4179,8 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([gnutls])], [
 dnl
 dnl RemoteOSD plugin (VNC client as video filter)
 dnl
-AC_ARG_ENABLE(remoteosd,
-  [  --disable-remoteosd     RemoteOSD plugin (default enabled)])
-
-AS_IF([VLC_FEATURE_NOT_DISABLED([remoteosd])], [
+VLC_FEATURE_OPTION([remoteosd], [RemoteOSD plugin])
+AS_IF([VLC_FEATURE_ENABLED([remoteosd])], [
   AS_IF([test "${have_libgcrypt}" = "yes"],[
     VLC_ADD_PLUGIN([remoteosd])
     VLC_ADD_LIBS([remoteosd], ${GCRYPT_LIBS})
@@ -4298,8 +4219,7 @@ AS_IF([test -f "/etc/maemo_version"], [
 dnl
 dnl update checking system
 dnl
-AC_ARG_ENABLE(update-check,
-  [  --enable-update-check   update checking system (default disabled)])
+VLC_FEATURE_OPTION([update-check], [update checking system], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([update-check])], [
   if test "${have_libgcrypt}" != "yes"
   then
@@ -4313,12 +4233,13 @@ AS_IF([VLC_FEATURE_ENABLED([update-check])], [
 dnl
 dnl SQLite
 dnl
+VLC_FEATURE_OPTION([sqlite], [sqlite support])
 AC_ARG_WITH(sqlite,
   [  --with-sqlite=PATH      sqlite path linking])
 if test "${SYS}" != "darwin"; then
   PKG_ENABLE_MODULES_VLC([SQLITE], [], [sqlite3 >= 3.6.0], [sqlite3], [auto])
 else
-  AS_IF([VLC_FEATURE_NOT_DISABLED([sqlite])], [
+  AS_IF([VLC_FEATURE_ENABLED([sqlite])], [
     AC_CHECK_HEADERS(sqlite3.h, [
         VLC_ADD_PLUGIN([sqlite])
         if test "${with_sqlite}" != "no" -a -n "${with_sqlite}"; then
@@ -4359,9 +4280,7 @@ dnl
 dnl  DLL loader copied from MPlayer copied from somewhere else (WINE ?)
 dnl
 loader=false
-AC_ARG_ENABLE(loader,
-  AS_HELP_STRING([--enable-loader],[build DLL loader for ELF i386 platforms
-		  (default disabled)]))
+VLC_FEATURE_OPTION([loader], [build DLL loader for ELF i386 platforms], [disabled])
 AM_CONDITIONAL(LOADER, [VLC_FEATURE_ENABLED([loader])])
 AS_IF([VLC_FEATURE_ENABLED([loader])],
   [ VLC_ADD_PLUGIN([dmo])
@@ -4376,22 +4295,22 @@ AC_ARG_WITH(,[Components:])
 dnl
 dnl  the VLC binary
 dnl
-AC_ARG_ENABLE(vlc,
-  [  --enable-vlc            build the VLC media player (default enabled)])
-AM_CONDITIONAL(BUILD_VLC, [VLC_FEATURE_NOT_DISABLED([vlc])])
+VLC_FEATURE_OPTION([vlc], [build the VLC media player])
+AM_CONDITIONAL(BUILD_VLC, [VLC_FEATURE_ENABLED([vlc])])
 
 dnl
 dnl  Microsoft ActiveX support
 dnl
 activex=false
-AC_ARG_ENABLE(activex,
-  AS_HELP_STRING([--enable-activex],[build a vlc-based ActiveX control
-		  (default enabled on Win32)]))
+AS_IF([test "${SYS}" = "mingw32"], [
+  VLC_FEATURE_DEFAULT_ENABLE([activex])
+], [
+  VLC_FEATURE_DEFAULT_DISABLE([activex])
+])
+VLC_FEATURE_OPTION([activex], [build a vlc-based ActiveX control], [enabled on Win32])
 AC_ARG_WITH(wine-sdk-path,
   [  --with-wine-sdk-path=PATH path to wine sdk])
-AS_IF([VLC_FEATURE_NOT_DISABLED([activex])], [
-  if test "${SYS}" = "mingw32"
-  then
+AS_IF([VLC_FEATURE_ENABLED([activex]) && test "${SYS}" = "mingw32"], [
     AC_CHECK_PROGS(MIDL, [midl], no)
     if test "${with_wine_sdk_path}" != ""
     then
@@ -4422,7 +4341,6 @@ AS_IF([VLC_FEATURE_NOT_DISABLED([activex])], [
       [ AC_MSG_ERROR([required OLE headers are missing from your system]) ]
     )
     AC_LANG_POP(C++)
-  fi
 ])
 AC_ARG_VAR(MIDL, [Microsoft IDL compiler (Win32 platform only)])
 AM_CONDITIONAL(HAS_MIDL_COMPILER, test "${MIDL}" != "no")
@@ -4434,9 +4352,7 @@ dnl
 dnl  Mozilla plugin
 dnl
 mozilla=false
-AC_ARG_ENABLE(mozilla,
-  AS_HELP_STRING([--enable-mozilla],[build a vlc-based Firefox/Mozilla plugin
-		  (default disabled)]))
+VLC_FEATURE_OPTION([mozilla], [build a vlc-based Firefox/Mozilla plugin], [disabled])
 AC_ARG_WITH(mozilla-sdk-path,
   [  --with-mozilla-sdk-path=PATH path to mozilla sdk])
 AC_ARG_WITH(mozilla-pkg,
@@ -4602,8 +4518,7 @@ AM_CONDITIONAL(BUILD_MOZILLA,${mozilla})
 dnl
 dnl  test plugins
 dnl
-AC_ARG_ENABLE(testsuite,
-  [  --enable-testsuite      build test modules (default disabled)])
+VLC_FEATURE_OPTION([testsuite], [build test modules], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([testsuite])], [
   TESTS="test1 test2 test3 test4"
 
@@ -4860,10 +4775,10 @@ build flavour         : "
 AS_IF([VLC_FEATURE_ENABLED([debug])], [printf "debug "])
 AS_IF([VLC_FEATURE_ENABLED([cprof])], [printf "cprof "])
 AS_IF([VLC_FEATURE_ENABLED([gprof])], [printf "gprof "])
-AS_IF([VLC_FEATURE_NOT_DISABLED([optimizations])], [printf "optim "])
+AS_IF([VLC_FEATURE_ENABLED([optimizations])], [printf "optim "])
 AS_IF([VLC_FEATURE_ENABLED([release])], [printf "release "], [printf "devel "])
 echo ""
-AS_IF([VLC_FEATURE_NOT_DISABLED([vlc])], [
+AS_IF([VLC_FEATURE_ENABLED([vlc])], [
 echo "vlc aliases           :${ALIASES}"
 ], [
 echo "build vlc executable  : no"
diff --git a/m4/vlc_features.m4 b/m4/vlc_features.m4
index 80e3439..ee31713 100644
--- a/m4/vlc_features.m4
+++ b/m4/vlc_features.m4
@@ -109,12 +109,8 @@ dnl VLC_FEATURE_(NOT_)DEFAULT_ENABLED/DISABLED(ENABLE-STRING)
 dnl Check if a feature is (or isn't) default enabled/disabled by configure.ac authors.
 AC_DEFUN([VLC_FEATURE_DEFAULT_ENABLED],
   [_VLC_FEATURE_CHECK_VARIABLE([$1], [vlc_feature_default], [= "xyes" ])])
-AC_DEFUN([VLC_FEATURE_NOT_DEFAULT_ENABLED],
-  [_VLC_FEATURE_CHECK_VARIABLE([$1], [vlc_feature_default], [!= "xyes" ])])
 AC_DEFUN([VLC_FEATURE_DEFAULT_DISABLED],
   [_VLC_FEATURE_CHECK_VARIABLE([$1], [vlc_feature_default], [= "xno" ])])
-AC_DEFUN([VLC_FEATURE_NOT_DEFAULT_DISABLED],
-  [_VLC_FEATURE_CHECK_VARIABLE([$1], [vlc_feature_default], [!= "xno"])])
 
 
 
@@ -142,36 +138,12 @@ AC_DEFUN([VLC_FEATURE_REMOVED],
 AC_DEFUN([VLC_FEATURE_NOT_REMOVED],
   [AS_IF([VLC_FEATURE_REMOVED([$1])], [false], [true])])
 
-dnl VLC_FEATURE_(NOT_)ENABLED/DISABLED(ENABLE-STRING)
-dnl Check if a feature is (or isn't) explicitly or default enabled/disabled.
+dnl VLC_FEATURE_ENABLED/DISABLED(ENABLE-STRING)
+dnl Check if a feature is explicitly or default enabled/disabled.
 AC_DEFUN([VLC_FEATURE_ENABLED],
-  [{ \]
-    [VLC_FEATURE_REQUESTED([$1])][ \]
-    [ || \]
-    [{ \]
-        [VLC_FEATURE_NOT_FORCE_DISABLED([$1])][ \]
-        [ && \]
-        [VLC_FEATURE_NOT_USER_DISABLED([$1])][ \]
-        [ && \]
-        [VLC_FEATURE_DEFAULT_ENABLED([$1])][ \]
-    [; } \]
-  [; }])
-AC_DEFUN([VLC_FEATURE_NOT_ENABLED],
-  [AS_IF([VLC_FEATURE_ENABLED([$1])], [false], [true])])
+  [_VLC_FEATURE_CHECK_VARIABLE([$1], [vlc_feature], [= "xyes"])])
 AC_DEFUN([VLC_FEATURE_DISABLED],
-  [{ \]
-    [VLC_FEATURE_REMOVED([$1])][ \]
-    [ || \]
-    [{ \]
-        [VLC_FEATURE_NOT_FORCE_ENABLED([$1])][ \]
-        [ && \]
-        [VLC_FEATURE_NOT_USER_ENABLED([$1])][ \]
-        [ && \]
-        [VLC_FEATURE_DEFAULT_DISABLED([$1])][ \]
-    [; } \]
-  [; }])
-AC_DEFUN([VLC_FEATURE_NOT_DISABLED],
-  [AS_IF([VLC_FEATURE_DISABLED([$1])], [false], [true])])
+  [_VLC_FEATURE_CHECK_VARIABLE([$1], [vlc_feature], [= "xno"])])
 
 
 
@@ -189,11 +161,11 @@ dnl VLC_FEATURE_DEFAULT_{ENABLE,DISABLE} prior to calling this macro.
 dnl Only if DEFAULT-STRING is "enabled" the configure output will show --disable-foo.
 dnl So for example "enabled on BSD" will still print --enable-foo.
 AC_DEFUN([VLC_FEATURE_OPTION], [
-  m4_pushdef([default_string], m4_default([$3], [enabled]))
+  m4_pushdef([default_string], m4_default_quoted([$3], [enabled]))
   m4_pushdef([var], [vlc_feature_]_VLC_FEATURE_STRING([$1]))
   m4_ifblank([$2], [m4_fatal([Don't leave description blank for $1])])
 
-  m4_case(default_string,
+  m4_case(m4_quote(default_string),
     [enabled], [
       m4_pushdef([with_without], [--disable-$1])
       VLC_FEATURE_DEFAULT_ENABLE([$1])
@@ -224,10 +196,7 @@ AC_DEFUN([VLC_FEATURE_OPTION], [
     AC_MSG_ERROR([You cannot --enable-$1 it was force disabled.])
   ])
 
-  AC_ARG_ENABLE([$1], [
-    AS_HELP_STRING(with_without,
-                   m4_quote([$2])[ @<:@default: ]m4_quote(default_string)[@:>@])
-  ])
+  AC_ARG_ENABLE([$1], [AS_HELP_STRING(with_without, m4_quote([$2])[ @<:@default: ]m4_quote(default_string)[@:>@])])
 
   AS_IF([test "x${]var[}" = "x"], [AS_IF([VLC_FEATURE_REQUESTED([$1])], var="yes")])
   AS_IF([test "x${]var[}" = "x"], [AS_IF([VLC_FEATURE_REMOVED([$1])], var="no")])
diff --git a/m4/with_pkg.m4 b/m4/with_pkg.m4
index a70dc1d..3f6cddc 100644
--- a/m4/with_pkg.m4
+++ b/m4/with_pkg.m4
@@ -41,7 +41,8 @@ m4_pushdef([description],
 AC_ARG_ENABLE(with_arg,
      AS_HELP_STRING([--enable-]with_arg, description[ @<:@default=]auto[@:>@]))
 
-AS_IF([VLC_FEATURE_NOT_DISABLED(with_arg)], [
+VLC_FEATURE_DEFAULT_ENABLE(with_arg)
+AS_IF([VLC_FEATURE_ENABLED(with_arg)], [
      PKG_CHECK_MODULES([$1],[$2],[$3],[$4])])
 
 m4_popdef([with_arg])
-- 
1.6.6.1

